/**
 * Created by AlexanderC on 5/27/15.
 */

'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.Action = undefined;

var _Extractable = require('./Extractable');

var _Service = require('../Service');

var _InvalidArgumentException = require('../../Exception/InvalidArgumentException');

var _Policy = require('./Policy');

/**
 * Iam statement action
 */
class Action extends _Extractable.Extractable {
  /**
   * @param {String} service
   * @param {String} actionName
   */
  constructor(service = _Service.Service.ANY, actionName = _Policy.Policy.ANY) {
    super();

    this._service = null;
    this._action = actionName;

    this.service = service;
  }

  /**
   * @param {String} action
   */
  set action(action) {
    this._action = action;
  }

  /**
   * @returns {String}
   */
  get action() {
    return this._action;
  }

  /**
   * @param {String} name
   */
  set service(name) {
    if (!_Service.Service.exists(name)) {
      throw new _InvalidArgumentException.InvalidArgumentException(name, _Service.Service);
    }

    this._service = name;
  }

  /**
   * @returns {String}
   */
  get service() {
    return this._service;
  }

  /**
   * @returns {String}
   */
  extract() {
    let service = this._service;
    let action = this._action;

    return `${service}:${action}`;
  }
}
exports.Action = Action;