/**
 * Created by AlexanderC on 5/27/15.
 */

'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.Policy = undefined;

var _Extractable = require('./Extractable');

var _Collection = require('./Collection');

var _Statement = require('./Statement');

/**
 * IAM policy
 */
class Policy extends _Extractable.Extractable {
  constructor() {
    super();

    this._version = Policy.DEFAULT_VERSION;
    this._statement = new _Collection.Collection(_Statement.Statement);
  }

  /**
   * @returns {String}
   */
  static get ANY() {
    return '*';
  }

  /**
   * @returns {String}
   */
  static get DEFAULT_VERSION() {
    return '2012-10-17';
  }

  /**
   * @param {String} version
   */
  set version(version) {
    this._version = version;
  }

  /**
   * @returns {String}
   */
  get version() {
    return this._version;
  }

  /**
   * @returns {Collection}
   */
  get statement() {
    return this._statement;
  }

  /**
   * @return {Object}
   */
  extract() {
    return {
      Version: this._version,
      Statement: this._statement.extract()
    };
  }

  /**
   * @return {String}
   */
  toString() {
    return JSON.stringify(this.extract());
  }
}
exports.Policy = Policy;