/**
 * Created by AlexanderC on 5/25/15.
 */

'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.MethodsNotImplementedException = undefined;

var _Exception = require('./Exception');

var _InvalidArgumentException = require('./InvalidArgumentException');

/**
 * Thrown when methods from interface or abstract class are not implemented
 */
class MethodsNotImplementedException extends _Exception.Exception {
  /**
   * @param {Array} methods
   */
  constructor(methods) {
    if (!Array.isArray(methods)) {
      throw new _InvalidArgumentException.InvalidArgumentException(methods, 'Array');
    }

    let methodPlain = methods.join(', ');

    super(`One or more method are not implemented (${methodPlain}).`, 500);
  }
}
exports.MethodsNotImplementedException = MethodsNotImplementedException;