/**
 * Created by mgoria on 7/28/16.
 */

'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.ResourceNotFoundException = undefined;

var _Exception = require('./Exception');

/**
 * Thrown when resource not found
 */
class ResourceNotFoundException extends _Exception.Exception {
  /**
   * @param {String|Number|null} resourceName
   */
  constructor(resourceName = null) {
    let message = resourceName ? `Resource "${resourceName}" was not found.` : 'Resource not found.';

    super(message, 404);
  }
}
exports.ResourceNotFoundException = ResourceNotFoundException;