/**
 * Created by AlexanderC on 5/27/15.
 */

'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.UniversalRequire = undefined;

var _path = require('path');

var _path2 = _interopRequireDefault(_path);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

class UniversalRequire {
  constructor() {
    this._require = this._guessRequireFunc();
  }

  /**
   * @param {String} module
   * @param {Function} cb
   * @returns {*}
   */
  require(module, cb) {
    if (UniversalRequire._isFrontend) {
      module = _path2.default.normalize(module); // avoid './' or '../'
    }

    return this._require(module, cb);
  }

  /**
   * @returns {Boolean}
   * @private
   */
  static get _isFrontend() {
    return typeof window !== 'undefined' && typeof document !== 'undefined';
  }

  /**
   * @returns {Function}
   * @private
   */
  _guessRequireFunc() {
    if (!UniversalRequire._isFrontend) {
      return (module, cb) => {
        try {
          cb(null, require(module));
        } catch (e) {
          cb(e, null);
        }
      };
    }

    require('./require1k.js');

    return window.__deepRequireBrowser__;
  }
}
exports.UniversalRequire = UniversalRequire;