/**
 * Created by AlexanderC on 5/25/15.
 */

'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.Interface = undefined;

var _MethodsNotImplementedException = require('../Exception/MethodsNotImplementedException');

/**
 * Interface implementation
 */
class Interface {
  /**
   * @param {String[]|String} abstractMethods
   */
  constructor(...abstractMethods) {
    let methods = abstractMethods.length === 1 && abstractMethods[0] instanceof Array ? abstractMethods[0] : abstractMethods;

    let notImplementedMethods = [];

    for (let abstractMethodKey in methods) {
      if (!methods.hasOwnProperty(abstractMethodKey)) {
        continue;
      }

      let abstractMethod = methods[abstractMethodKey];
      if (!(this[abstractMethod] instanceof Function)) {
        notImplementedMethods.push(abstractMethod);
      }
    }

    if (notImplementedMethods.length > 0) {
      throw new _MethodsNotImplementedException.MethodsNotImplementedException(notImplementedMethods);
    }
  }
}
exports.Interface = Interface;